\"			-*-Text-*-
.TH barasgn l "" "" "\fBCray Compatibility Library: libCRAY.a\fP" 
.SH NAME
barasgn \- Initilize a Barrier synchronization variable
.SH SYNOPSIS
\fBcall barasgn( barrier , bar_count )\fR
.br
\fBinteger barrier, bar_count\fR
.SH ARGUMENTS
.B barrier
.RS
Integer variable (in shared memory) to be used as a barrier.
The user must not modify an barrier variable after the call to
\fIbarasgn\fR until that variable is released by a call to \fIbarrel\fR.
.RE
.B bar_count
.RS
The integer number of tasks that must invoke the barrier
synchronization routine with this barrier variable in order for it to
change to an `open' state.
.RE
.SH DESCRIPTION
\fIBarasgn\fR identifes an integer variable that the program intends to
use as a barrrier.
The \fIbarasgn\fR subroutine must be called for each barrier variable
before its use with any other barrier routines.
A barrier is given the initial state of `closed'.
A barrier remains `closed' until its count is met, ie, it has been
invoked by as many tasks as its defined count indicates.
.SH FILES
/usr/local/lib/libCRAY.a
.SH "SEE ALSO"
\fIbarrel(l)\fR, \fIbarsync(l)\fR
.SH BUGS
If a barrier variable is not assigned before use in any of the other
barrier subroutines, the results are unpredictable!
